#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# D-Case Weaver 1.1.1
#
# Copyright (c) 2012-2014 JST DEOS R&D Center
#
# Licensed under The MIT License
#

import urllib
import urllib2
import cookielib
from optparse import OptionParser

usage = '''usage: %prog update -n NODE_ID [-s STATUS] [-m MESSAGE] [-H HOST] DCASE_ID
       %prog delete [-n NODE_ID] [-H HOST] DCASE_ID
       %prog list [-n NODE_ID] [-H HOST] DCASE_ID'''
parser = OptionParser(usage=usage)
parser.add_option("-n", "--node-id", help=u"ノードID")
parser.add_option("-s", "--status", help=u"ステータス")
parser.add_option("-m", "--message", help=u"メッセージ")
parser.add_option("-H", "--host", dest="host", help=u"リモート実行する場合はホスト名を指定してください。", metavar="HOST")

options, args = parser.parse_args()

if len(args) < 2:
    parser.print_help()
    exit(-1)

cmd = args[0]
dcase_id = args[1]
node_id = options.node_id
status = options.status
message = options.message
host = options.host if options.host else 'localhost'

url = "http://%s/dcase-weaver/cgi-bin/node-status.wsgi/%s" % (host, dcase_id)

if cmd == 'list':
    if node_id:
        query = {"id": node_id}
        url += "?" + urllib.urlencode(query)

    request = urllib2.Request(url)

    opener = urllib2.build_opener(urllib2.HTTPHandler)
    response = opener.open(request)

    print response.read()


elif cmd == 'update':
    if node_id is None:
        parser.print_help()
        exit(-1)

    query = {"id": node_id}
    if status: query['status'] = status
    if message: query['message'] = message

    url += "?" + urllib.urlencode(query)

    request = urllib2.Request(url)
    request.get_method = lambda: "PUT"

    opener = urllib2.build_opener(urllib2.HTTPHandler)
    response = opener.open(request)

    print response.read()


elif cmd == 'delete':
    if node_id:
        query = {"id": node_id}
        url += "?" + urllib.urlencode(query)

    request = urllib2.Request(url)
    request.get_method = lambda: "DELETE"

    opener = urllib2.build_opener(urllib2.HTTPHandler)
    response = opener.open(request)

    print response.read()


else:
    parser.print_help()
    exit(-1)
