# D-Case Weaver 1.1.1
#
# Copyright (c) 2012-2014 JST DEOS R&D Center
#
# Licensed under The MIT License
#
import cgi
import urllib
import urllib2
import syslog

Status = {
    200: "200 OK",
    201: "201 Created",
    400: "400 Bad Request",
    401: "401 Unauthorized",
    404: "404 Not Found",
    500: "500 Internal Server Error",
    550: "550 Permission denied"
};

def debug (msg):
    syslog.syslog(syslog.LOG_DEBUG, msg)

class DSBenchProxy(object):
    def __init__(self):
        pass

    def __call__(self, environ, start_response):
        pathinfo = environ["PATH_INFO"]

        query = dict(cgi.parse_qsl(environ["QUERY_STRING"]))

        url = query["url"]
        del query["url"]

        if pathinfo == "/scenario_list":
            url += "/get_scenario_list.cgi"
            response = urllib2.urlopen(url)

        elif pathinfo == "/scenario_detail":
            name = query["name"]
            url += "/get_scenario_detail.cgi?name=%s" % name
            response = urllib2.urlopen(url)

        elif pathinfo == "/run_scenario":
            url += "/run_scenario.cgi"

            wsgiinput = environ['wsgi.input']
            length = int(environ.get('CONTENT_LENGTH', 0))

            data = wsgiinput.read(length)

            headers = {"Content-Type": "text/xml"}
            request = urllib2.Request(url, data=data, headers=headers)
            response = urllib2.urlopen(request)

        elif pathinfo == "/status":
            url += "/get_state_result.cgi?" + urllib.urlencode(query);

            response = urllib2.urlopen(url)

        elif pathinfo == "/stop_scenario":
            url += "/stop_scenario.cgi"

            wsgiinput = environ['wsgi.input']
            length = int(environ.get('CONTENT_LENGTH', 0))

            data = wsgiinput.read(length)

            headers = {"Content-Type": "text/xml"}
            request = urllib2.Request(url, data=data, headers=headers)
            response = urllib2.urlopen(request)

        headers = [("Content-Type", response.info().getheader("Content-Type"))]
        start_response(Status[200], headers)

        data = response.read()

        return data

application = DSBenchProxy()
